/****************************************************************************
* Zn5 Mpkgbox port/modification by kidscracker
* E8 MpkgBox source file by ilove3d
* keep author information if you redistribute this program
* Nov. 2008
* http://moto.it168.com
*
*
* Ported by: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#include "MpkgBoxGUI.h"

char *locale_buf=NULL;
QString app_basedir=NULL;
char exec_buffer[512];
struct appobj *sd_appobjects=NULL;
struct appobj *phone_appobjects=NULL;
struct appobj *sd_insobjects=NULL;

QDir homePath;
LanguageConfig*llc = NULL;

#ifdef EZX_ZN5
QString s7zipPath = "./p7zip/7z";
#endif
#ifdef EZX_Z6
QString s7zipPath = "/mmc/mmca1/.Programs/mgxbox/p7zip/7z";
#endif
bool f7z_found = false;

QString ctr(const char*ChineseString)
{
	QTextCodec* gbkstr = QTextCodec::codecForName("UTF-8");
	return gbkstr->toUnicode(ChineseString);
}

void readconfig(const char* buf, const char *key, char *dest)
{
	char *mystr=strdup(buf);
	memset(dest, 0, sizeof(dest));
	char *p=strtok(mystr, "\n");
	while (p!=NULL) {
		if (strncmp(p, key, strlen(key))==0) {
			strcpy(dest, p+strlen(key));
			break;
		}
		memset(p, 0, sizeof(p));
		p=strtok(NULL, "\n");
	}
	free(mystr);
}

void setconfig(const char *buf, const char *key, const char *value, char *dest)
{
	char *mystr=strdup(buf);
	char temp[512];
	memset(dest, 0, sizeof(dest));
	char *p=strtok(mystr, "\n");
	while (p!=NULL) {
		sprintf(temp, "%s\n", p);
		if (strncmp(temp, key, strlen(key))==0) {
			sprintf(temp, "%s = %s\n", key, value);
		}
		strcat(dest, temp);
		memset(p, 0, sizeof(p));
		p=strtok(NULL, "\n");
	}
	free(mystr);
}

int mod(char *buf)
{
	if (strcmp(buf, "")==0) {
		//printf("Debug: empty input\n");
		return -1;
	}
	unsigned int i;
	unsigned int j=0;
	unsigned int k=strlen(buf);
	unsigned int l=0;
	for (i=0; i<k; i++, j++) {
		if (buf[i]!=' ') break;
	}
	if (j==k) {
		//printf("all blank input\n");
		return -1;
	}
	for (i=k-1; i>0; i--, l++) {
		if (buf[i]!=' ') break;
	}
	buf[k-l]=0;
	return j;
}

// Functions for object list manipulations.
void list_append_obj(struct appobj**root, struct appobj *tmpobj)
{
	if (*root==NULL) {
		*root=tmpobj;
		return;
	}

	struct appobj *p;
	p=*root;

	while (true) {
		if (p->next==NULL) break;
		p=p->next;
	}

	p->next=tmpobj;
	tmpobj->next=NULL;
}


// Functions for listing Mgx installers
void ListAllMgx()
{
	QString sDefaultDir = SD_INSTALLERS_DIR;
	QString sDefaultExt = "*.mgx";
	struct appobj *tmpobj=NULL;
	int i, nCount;

	int nFilterSpec = QDir::Files | QDir::Hidden;
	QDir dir(sDefaultDir, sDefaultExt, QDir::Name | QDir::IgnoreCase, nFilterSpec );

	nCount = dir.count();
	for (i = 0; i < nCount; i ++)
	{
		if ("." == dir[i] | ".." == dir[i]) continue;
		
		tmpobj=(struct appobj *)malloc(sizeof(struct appobj));
		memset(tmpobj, 0, sizeof(struct appobj));
		tmpobj->next=NULL;
		sprintf(tmpobj->name, "%s", dir[i].ascii());
		sprintf(tmpobj->path, "%s/%s", sDefaultDir.ascii(), dir[i].ascii());
		list_append_obj(&sd_insobjects, tmpobj);
	}
}

//		ZKbMainWidget((ZHeader::HEADER_TYPE)3, parent, "E8MpkgBox", 0)
MpkgBoxGUI::MpkgBoxGUI(QWidget *parent) :
		ZKbMainWidget(parent, "MgxBox", 0)
{
	setAppTitle(ctr("MgxBox"));

	char execbuf[256];
	sprintf(execbuf, "mkdir -p '%s'; mkdir -p '%s'; mkdir -p '%s'", SD_BASE_DIR, PH_BASE_DIR);
	printf("Debug: system(%s)\n", execbuf);
	system(execbuf);

	app_basedir=QString(qApp->argv()[0]);

	homePath = QDir( QString( dirname( qApp->argv()[0] ) ) );
/*
	printf("Debug: system(%s)\n", QString("export LD_PRELOAD=%1").arg( homePath.filePath("libgcc_s.so.1")).ascii());
	system( QString("export LD_PRELOAD=%1").arg( homePath.filePath("libgcc_s.so.1")) );
*/
	// Default Layaout is Vertical
	QVBoxLayout* layout = getVBoxLayout();

	SoftKey = new ZSoftKey(tr("CST_2A"), this, this);

	QRect rect = ZGlobal::getContentR();

	QDir cardDir=QDir(ctr(SD_BASE_DIR));
	if (cardDir.exists()==true) {
		CardExist = true;
	} else {
		CardExist = false;
	}

	SoftKey->setText(ZSoftKey::LEFT, lc("Опции"), ZSoftKey::TEXT_PRIORITY(0));
	SoftKey->setText(ZSoftKey::RIGHT, lc("Выход"), ZSoftKey::TEXT_PRIORITY(0));

	SoftKey->setTextForOptMenuHide(lc("Опции"));
	SoftKey->setTextForOptMenuShow(lc("Выбор"), lc("Отмена"));

	SoftKey->setClickedSlot(ZSoftKey::LEFT, this, SLOT(options()));
	SoftKey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT(quit()));

	znavtabwidget = new ZNavTabWidget(this, 0, (ZSkinService::WidgetClsID)63);
	ZSetLayout(znavtabwidget , ZGlobal::getContentR());
	znavtabwidget->stopNextWhenKeyRepeat(FALSE);

	layout->addWidget(znavtabwidget);
	
	zlistbox_sd = new ZListBox("%I48%M", znavtabwidget);
	zlistbox_sd -> setAutoExpandInNestMode(true);
	znavtabwidget->addTab(zlistbox_sd, iconReader.getIcon("fm_memory_card_tab.bmp"), NULL /*tr("sd")*/);

	zlistbox_phone = new ZListBox("%I48%M", znavtabwidget);
	zlistbox_phone -> setAutoExpandInNestMode(true);
	znavtabwidget->addTab(zlistbox_phone, iconReader.getIcon("ctact_mobile_tab.bmp"), NULL /*tr("phone")*/);

	zlistbox_installers_sd = new ZListBox("%I48%M", znavtabwidget);
	zlistbox_installers_sd -> setAutoExpandInNestMode(true);
	znavtabwidget->addTab(zlistbox_installers_sd, QPixmap(homePath.filePath("package_s.png")), NULL /*tr("installers")*/);

	pleaseWaitDlg = new ZPopup((ZPopup::POPUP_TYPE_E)1);
	pleaseWaitDlg->setTitleIcon(tr("recur_enable_pop.bmp"));
	pleaseWaitDlg->setTitle(tr(" "));
	ZLabel *lb = new ZLabel(lc("Пожалуйста подождите..."), pleaseWaitDlg, 0, 0, (ZSkinService::WidgetClsID)1);
	pleaseWaitDlg->insertChild(lb);


	//pleaseWaitDlg->exec();
	pleaseWaitDlg->show();
	initBoxes();
	pleaseWaitDlg->hide();
	connect(zlistbox_phone, SIGNAL(selected(int)), this, SLOT(objectSelected(int)));
	connect(zlistbox_sd, SIGNAL(selected(int)), this, SLOT(objectSelected(int)));
	connect(zlistbox_installers_sd, SIGNAL(selected(int)), this, SLOT(objectSelected(int)));

	setSoftKey(SoftKey);
}

MpkgBoxGUI::~MpkgBoxGUI()
{
	freeobj(sd_appobjects);
	sd_appobjects=NULL;

	freeobj(phone_appobjects);
	phone_appobjects=NULL;

	if (locale_buf!=NULL) {
		free(locale_buf);
		locale_buf=NULL;
	}
}

QString MpkgBoxGUI::lc(const char *key)
{
	char lngfile[512];
	sprintf(lngfile, "%s_%s.lng", app_basedir.ascii(),"en-us");
	if (llc==NULL) llc = new LanguageConfig(lngfile);
	QString a = llc->getText(ctr(key));
	return a;
}

void MpkgBoxGUI::printobj(struct appobj *tmpobj)
{
	printf("---printobj----\n");
	struct appobj *p;
	p=tmpobj;

	while (p!=NULL) {
		printf("Path = '%s'\n", p->path);
		printf("Name = '%s'\n", p->name);
		printf("Icon = '%s'\n", p->icon);
		printf("Exec = '%s'\n", p->exec);
		printf("Author = '%s'\n", p->author);
		printf("Version = '%s'\n", p->version);
		printf("Comment = '%s'\n", p->comment);
		printf("-----------\n");
		p=p->next;
	}
}

void MpkgBoxGUI::freeobj(struct appobj *tmpobj)
{
	struct appobj *p, *q;
	p=tmpobj;

	while (p!=NULL) {
		q=p;
		p=p->next;
		free(q);
	}
}

struct appobj *MpkgBoxGUI::getCurObj() {
	int tabIndex=znavtabwidget->currentPageIndex();
	int phoneIndex=zlistbox_phone->currentItem();
	int sdIndex=zlistbox_sd->currentItem();
	int sdinsIndex=zlistbox_installers_sd->currentItem();
	//printf("Debug: tab[%d], sd[%d], phone[%d]\n", tabIndex, sdIndex, phoneIndex);
	int k=0;
	bool found=false;
	struct appobj *p=NULL;
	if (tabIndex==0) {
		if (sdIndex!=-1) {
			p=sd_appobjects;
			while (p!=NULL) {
				k++;
				if (k==sdIndex+1) {
					found=true;

					break;
				}
				p=p->next;
			}
		}
	}	else if (tabIndex==1) {
		if (phoneIndex!=-1) {
			p=phone_appobjects;
			while (p!=NULL) {
				k++;
				if (k==phoneIndex+1) {
					found=true;
					break;
				}
				p=p->next;
			}
		}
	} else if (tabIndex==2) {
//		return NULL;

		if (sdinsIndex!=-1) {
			p=sd_insobjects;
			while (p!=NULL) {
				k++;
				if (k==sdinsIndex+1) {
					found=true;
					break;
				}
				p=p->next;
			}
		}
	}

	if (found) {
		return p;
	} else {
		ZNoticeDlg *dlg=new ZNoticeDlg((ZNoticeDlg::Type)1, 2000, lc("Ошибка!"), lc("Приложения не выбраны!"));
		dlg->setTitleIcon(tr("error_pop.bmp"));
		dlg->exec();
		delete dlg;
		printf("Debug: Object not found!\n");
		return NULL;
	}
}

void MpkgBoxGUI::append_sd_obj(struct appobj *tmpobj)
{
	list_append_obj(&sd_appobjects,tmpobj);
	return;
}

void MpkgBoxGUI::append_phone_obj(struct appobj *tmpobj)
{
	list_append_obj(&phone_appobjects,tmpobj);
	return;
}

void MpkgBoxGUI::delete_sd_obj(int index) // does not free the object
{
	struct appobj *p, *q;
	p=sd_appobjects;
	int k=0;
	if (index==-1) return;
	if (sd_appobjects==NULL) return;

	if (index==0) {
		sd_appobjects=p->next;
		//printobj(sd_appobjects);
		return;
	}

	while (p!=NULL) {
		k++;
		if (k==index) { // the object before target object
			q=p->next; // the real object to free
			p->next=q->next;
		}
		p=p->next;
	}
	//printobj(sd_appobjects);
}

void MpkgBoxGUI::delete_phone_obj(int index) // does not free the object
{
	struct appobj *p, *q;
	p=phone_appobjects;
	int k=0;
	if (index==-1) return;
	if (phone_appobjects==NULL) return;

	if (index==0) {
		phone_appobjects=p->next;
		//printobj(phone_appobjects);
		return;
	}

	while (p!=NULL) {
		k++;
		if (k==index) { // the object before target object
			q=p->next; // the real object to free
			p->next=q->next;
			break;
		}
		p=p->next;
	}
	//printobj(phone_appobjects);
}

void MpkgBoxGUI::append_obj_to_ui(struct appobj *tmpobj, ZListBox *target)
{
	ZSettingItem *pItem = new ZSettingItem(target);
	char iconpath[256];
	sprintf(iconpath, "%s/%s", tmpobj->path, tmpobj->icon);
	if (QFile::exists(ctr(iconpath))) pItem->setPixmap(0, QPixmap(ctr(iconpath)));
	else pItem->setPixmap(0, iconReader.getIcon("yes_no_pop.bmp"));

//	else pItem->setPixmap(0, iconReader.getIcon("yes_no_pop.bmp"));
	pItem->appendSubItem(1, ctr(tmpobj->name));
	pItem->appendSubItem(1, lc("Папка: ")+ctr(tmpobj->path+basename(tmpobj->path)));
	target->insertItem(pItem);
}

void MpkgBoxGUI::refreshView()
{
	zlistbox_sd->clear();
	zlistbox_phone->clear();
	zlistbox_installers_sd->clear();
	struct appobj *p=sd_appobjects;
	struct appobj *q=phone_appobjects;
	struct appobj *r=sd_insobjects;

	while (p!=NULL) {
		append_obj_to_ui(p, zlistbox_sd);
		p=p->next;
	}

	while (q!=NULL) {
		append_obj_to_ui(q, zlistbox_phone);
		q=q->next;
	}
	int i=0;
	while (r!=NULL) {
		append_obj_to_ui(r, zlistbox_installers_sd);
		ZSettingItem *pItem = (ZSettingItem*)zlistbox_installers_sd->item(i); 
		pItem->setPixmap(0, QPixmap( homePath.filePath("package.png") ) );
		r=r->next;
		i++;
	}
}

void MpkgBoxGUI::preLoadApps(char* AppsPath, struct appobj**root )
{
	// init the appobj node, then refreshview.
	DIR *dp;
	struct dirent *entry;
	struct stat statbuf;
	char filename[512]; // for cfg filename
	int cfgmark; // 3 for fine
	char linestr[512]; // for each line
	struct appobj *tmpobj=NULL; // for tmp use
	memset(linestr, '\0', 512);

	if ((dp=opendir(AppsPath))!=NULL) {
		chdir(AppsPath);
		while ((entry=readdir(dp))!=NULL) {
			if (!strcmp(entry->d_name, ".") || !strcmp(entry->d_name, "..")) continue;
			stat(entry->d_name, &statbuf);
			if (S_ISDIR(statbuf.st_mode)) { // it's a dir
				cfgmark=0;
				tmpobj=(struct appobj *)malloc(sizeof(struct appobj));
				memset(tmpobj, 0, sizeof(struct appobj));
				tmpobj->next=NULL;
				sprintf(filename, "%s/%s/%s.cfg", AppsPath, entry->d_name, entry->d_name);
				sprintf(tmpobj->path, "%s/%s", AppsPath, entry->d_name);

				QFile cfgfile(filename);
				if (cfgfile.open(IO_ReadOnly)) { // cfg file exists
					while (cfgfile.readLine(linestr, 512) != -1) {
						linestr[strlen(linestr)-1]='\0';
						if (strstr(linestr, "Name = ")==linestr) {
							cfgmark++;
							sprintf(tmpobj->name, linestr+7);
						} else if (strstr(linestr, "Exec = ")==linestr) {
							cfgmark++;
							sprintf(tmpobj->exec, linestr+7);
						} else if (strstr(linestr, "Icon = ")==linestr) {
							cfgmark++;
							sprintf(tmpobj->icon, linestr+7);
						} else if (strstr(linestr, "Author = ")==linestr) {
							sprintf(tmpobj->author, linestr+9);
						} else if (strstr(linestr, "Version = ")==linestr) {
							sprintf(tmpobj->version, linestr+10);
						} else if (strstr(linestr, "Comment = ")==linestr) {
							sprintf(tmpobj->comment, linestr+10);
						}
					}
					if (cfgmark==3) {
						list_append_obj(root,tmpobj);
					} else {
						free(tmpobj);
						tmpobj=NULL;
					}
					cfgfile.close();
				}
			}
		}
	}

}

void MpkgBoxGUI::initBoxes()
{
	preLoadApps(SD_BASE_DIR, &sd_appobjects);
	printobj(sd_appobjects);
	preLoadApps(PH_BASE_DIR, &phone_appobjects);
	ListAllMgx();
	refreshView();
	return;
}

void MpkgBoxGUI::about()
{
	// type 2 V info
	// type 1 ? yes / no
	// type 0 E Ok[1] / Cancel[0]
#ifdef EZX_Z6
	ZMessageDlg *aboutDlg = new ZMessageDlg(lc("О программе..."), ctr("MgxBox by Kidscracker\nEmail:\nkidscracker@gmail.com\n------------------\nPorted on Z6 by EXL\nEmail:\nexlmotodev@gmail.com\nSpecial for XXX_S_B!\nThanks iLove3D, rock88\n 13.08.2011"), (ZMessageDlg::MessageDlgType)2);
	aboutDlg->exec();
	delete aboutDlg;
#endif
#ifdef EZX_ZN5
	ZMessageDlg *aboutDlg = new ZMessageDlg(lc("О программе..."), ctr("MgxBox by Kidscracker\nEmail:\nkidscracker@gmail.com\n------------------\nPorted on ZN5 by EXL\nEmail:\nexlmotodev@gmail.com\nSpecial for XXX_S_B!\nThanks iLove3D, rock88\n 13.08.2011"), (ZMessageDlg::MessageDlgType)2);
	aboutDlg->exec();
	delete aboutDlg;
#endif
	
}

void MpkgBoxGUI::quit()
{
	qApp->quit();
}

void MpkgBoxGUI::rename()
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;

	ZSingleCaptureDlg* dlg = new ZSingleCaptureDlg(
	    lc("Переименовать приложение"), lc("Текушее имя: ")+ctr(curobj->name),
	    (ZSingleCaptureDlg::CaptureDlgType)0, NULL, "ZSingleCaptureDlg", true, 0, 0);
	ZLineEdit *line = dlg->getLineEdit();
	line->selectAll();
	dlg->exec();
	int result = dlg->result();

	char resultName[128];
	int cut=0;
	if (result) {
		sprintf(resultName, dlg->getResultText().utf8());
		cut=mod(resultName);
		if (cut!=-1) {
			printf("Debug: setup to '%s'\n", resultName+cut);
			delete dlg;
		} else {
			delete dlg;
			return;
		}
	} else {
		delete dlg;
		return;
	}

	char filename[512];
	sprintf(filename, "%s/%s.cfg", curobj->path, curobj->path+basename(curobj->path));
	int filesize;
	char *cfgbuf=NULL;
	QFile cfgfile(ctr(filename));

	if (cfgfile.open(IO_ReadOnly)) {
		filesize=cfgfile.size();
		cfgbuf=(char *)malloc(filesize+512); // space for a new name
		cfgfile.readBlock(cfgbuf, filesize);
		cfgbuf[filesize]='\0';
		setconfig(cfgbuf, "Name", resultName+cut, cfgbuf);
		cfgfile.close();
		cfgfile.remove();

		if (cfgfile.open(IO_WriteOnly)) {
			cfgfile.writeBlock(cfgbuf, strlen(cfgbuf));
			cfgfile.close();
			sprintf(curobj->name, resultName+cut);
			int phoneIndex=zlistbox_phone->currentItem();
			int sdIndex=zlistbox_sd->currentItem();
			refreshView();
			zlistbox_phone->setCurrentItem(phoneIndex);
			zlistbox_sd->setCurrentItem(sdIndex);
		} else {
			printf("Debug: error write cfg file '%s'\n", filename);
		}
	} else {
		printf("Debug: error open cfg file '%s'\n", filename);
	}
}

void MpkgBoxGUI::move()
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;
	ZMessageDlg *moveDlg = new ZMessageDlg(lc("Перемещение приложения"),
	                                       lc("Вы действительно хотите переместить %1 ?").arg( ctr(curobj->name) ),
                                           (ZMessageDlg::MessageDlgType)1);
	int ret=moveDlg->exec();
	delete moveDlg;
	if (ret!=1) return;

	int tabIndex=znavtabwidget->currentPageIndex();
	int phoneIndex=zlistbox_phone->currentItem();
	int sdIndex=zlistbox_sd->currentItem();
	char execbuf[512];
	char tmp[512];

	if (tabIndex==0) { // sd card
		if (sdIndex!=-1) {
			zlistbox_sd->removeItem(sdIndex);
			delete_sd_obj(sdIndex);
			append_phone_obj(curobj);
			append_obj_to_ui(curobj, zlistbox_phone);
			sprintf(execbuf, "mv '%s' '%s/'", curobj->path, PH_BASE_DIR);

			sprintf(tmp, "%s/%s", PH_BASE_DIR, curobj->path+basename(curobj->path));
			sprintf(curobj->path, tmp);

			pleaseWaitDlg->show();
			sprintf(exec_buffer, execbuf);
			QTimer::singleShot(10, this, SLOT(system_exec()));
			return;
		}
	} else if (tabIndex==1) { // phone
		if (phoneIndex!=-1) {
			zlistbox_phone->removeItem(phoneIndex);
			delete_phone_obj(phoneIndex);
			append_sd_obj(curobj);
			append_obj_to_ui(curobj, zlistbox_sd);
			sprintf(execbuf, "mv '%s' '%s/'", curobj->path, SD_BASE_DIR);

			sprintf(tmp, "%s/%s", SD_BASE_DIR, curobj->path+basename(curobj->path));
			sprintf(curobj->path, tmp);

			pleaseWaitDlg->show();
			sprintf(exec_buffer, execbuf);
			QTimer::singleShot(10, this, SLOT(system_exec()));
			return;
		}
	}
}

void MpkgBoxGUI::del()
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;

	ZMessageDlg *delDlg = new ZMessageDlg(lc("Удаление приложения"),
	                                      lc("Вы действительно хотите удалить %1 ?").arg( ctr(curobj->name) ),
                                          (ZMessageDlg::MessageDlgType)1);
	int ret=delDlg->exec();
	delete delDlg;
	if (ret!=1) return;

	int tabIndex=znavtabwidget->currentPageIndex();
	int phoneIndex=zlistbox_phone->currentItem();
	int sdIndex=zlistbox_sd->currentItem();
	char execbuf[512];

	if (tabIndex==2)
		return;

	sprintf(execbuf, "rm -rf '%s'", curobj->path);

	pleaseWaitDlg->show();
	sprintf(exec_buffer, execbuf);
	QTimer::singleShot(10, this, SLOT(system_exec()));

	if (tabIndex==0) { // sd card
		if (sdIndex!=-1) {
			zlistbox_sd->removeItem(sdIndex);
			delete_sd_obj(sdIndex);
			free(curobj);
			return;
		}
	} else if (tabIndex==1) { // phone
		if (phoneIndex!=-1) {
			zlistbox_phone->removeItem(phoneIndex);
			delete_phone_obj(phoneIndex);
			free(curobj);
			return;
		}
	}
}

void MpkgBoxGUI::options()
{
	int tabIndex=znavtabwidget->currentPageIndex();

	QStringList slLocations;
	if (tabIndex!=2)
	{
		if (CardExist)
			slLocations+=lc("Переместить");
		slLocations+=lc("Удалить");
		slLocations+=lc("Свойства");
		slLocations+=lc("Сохранить как MGX");
	}
	slLocations+=lc("О программе...");

	ZSingleSelectDlg* pSSD = new ZSingleSelectDlg( lc("Опции:"), lc("Пожалуйста выберите:"), NULL, "ZSingleSelectDlg", true, 0, 0);
		pSSD->addItemsList(slLocations);
	int iLoc = pSSD->exec();

	if (iLoc==0) return;
	iLoc = pSSD->getCheckedItemIndex();

	if (!CardExist & tabIndex!=2)
		iLoc++;

	switch(iLoc)
	{
		case 0:
			if (tabIndex==2)
				about();
			else
				move();			
			break;
		case 1:
			del();
			break;
		case 2:
			props();
			break;
		case 3:
			save();
			break;
		case 4:
			about();
			break;
	}
}

void MpkgBoxGUI::props()
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;

	QString propbuf="";
	propbuf+=lc("Имя: ");
	propbuf+=ctr(curobj->name)+"\n";
	propbuf+=lc("Папка: ");
	propbuf+=ctr(curobj->path+basename(curobj->path))+"\n";
	propbuf+=lc("Автор: ");
	propbuf+=ctr(curobj->author)+"\n";
	propbuf+=lc("Версия: ");
	propbuf+=ctr(curobj->version)+"\n";
	propbuf+=lc("Комментарий: ");
	propbuf+=ctr(curobj->comment);

	ZMessageDlg *propDlg = new ZMessageDlg(lc("Просмотр свойств"), propbuf, (ZMessageDlg::MessageDlgType)2);
	propDlg->setTitleIcon(tr("info_pop.bmp"));
	propDlg->exec();
	delete propDlg;
	return;
}

void MpkgBoxGUI::save()
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;

	if (Check7z())
		return;

	ZSingleSelectDlg * pathDlg = new ZSingleSelectDlg(lc("Выберите папку для сохранения"), ctr(""));
	QStringList strlist;
	strlist+=lc("Память телефона")+"/mgx";
	if (CardExist) strlist+=lc("Карта памяти")+"/mgx";
	pathDlg->addItemsList(strlist);
	pathDlg->setTitleIcon(tr("save_pop.bmp"));
	pathDlg->exec();
	int ret=pathDlg->getCheckedItemIndex();
	delete pathDlg;

	char *targetpath;
	if (ret==0) {
		targetpath="/ezxlocal/download/mystuff/mgx";
		system("mkdir -p /ezxlocal/download/mystuff/mgx");
	} else if (ret==1) {
		targetpath="/mmc/mmca1/mgx";
		system("mkdir -p /mmc/mmca1/mgx");
	} else {
		return;
	}

	char execbuf[512];
	char dirname[256];
	sprintf(dirname, curobj->path+basename(curobj->path));
	int tabIndex=znavtabwidget->currentPageIndex();

	sprintf(execbuf, "rm -f '%s/%s.mgx'", targetpath, dirname); // first clean up old file
	printf("Debug: system(%s)\n", execbuf);
	system(execbuf);

	if (tabIndex==0) { // sd
#ifdef OCM
		sprintf(execbuf, "cd '%s'; %s a -y '%s/%s.mgx' '%s'",
			SD_BASE_DIR, s7zipPath.ascii(), targetpath, dirname, dirname);
#else
		sprintf(execbuf, "cd '%s'; export LD_PRELOAD=%s ; %s a -y '%s/%s.mgx' '%s'",
                SD_BASE_DIR, homePath.filePath("libgcc_s.so.1").ascii(), s7zipPath.ascii(), targetpath, dirname, dirname);
#endif
	} else {
#ifdef OCM
		sprintf(execbuf, "cd '%s'; %s a -y '%s/%s.mgx' '%s'",
			PH_BASE_DIR, s7zipPath.ascii(), targetpath, dirname, dirname);
#else
		sprintf(execbuf, "cd '%s'; export LD_PRELOAD=%s ; %s a -y '%s/%s.mgx' '%s'",
                PH_BASE_DIR, homePath.filePath("libgcc_s.so.1").ascii(), s7zipPath.ascii(), targetpath, dirname, dirname);
#endif
	}

	pleaseWaitDlg->show();
	sprintf(exec_buffer, execbuf);
	QTimer::singleShot(10, this, SLOT(system_exec()));
}

void MpkgBoxGUI::objectSelected(int x)
{
	struct appobj *curobj=getCurObj();
	if (curobj==NULL) return;
	char execbuf[512];
	if (znavtabwidget->currentPageIndex() == 2 )
	{
		ZMessageDlg *delDlg = new ZMessageDlg(lc("Установка MGX пакета"),
						lc("Вы действительно хотите установить MGX: %1 ?").arg (ctr(curobj->name)),
						(ZMessageDlg::MessageDlgType)1);
		int ret=delDlg->exec();
		delete delDlg;
		if (ret!=1) return;

		QStringList slLocations;
		slLocations+=lc("Память телефона");
		if ( CardExist ) 
			slLocations+=lc("Карта памяти");

		ZSingleSelectDlg* pSSD = new ZSingleSelectDlg( lc("Установка"), lc("Выберите локацию для MGX:"), NULL, "ZSingleSelectDlg", true, 0, 0);
			pSSD->addItemsList(slLocations);
		int iLoc = pSSD->exec();
#define use_7zip
#ifdef use_7zip

		//s7zipPath = homePath.filePath("p7zip/7z");
		if (Check7z())
			return;

		system( QString("chmod +x %1").arg( s7zipPath ) );
#ifdef OCM
		QString sCmd = QString("%2 x -y %3 ").arg( s7zipPath ).arg( ctr(curobj->path) );
#else
		QString sCmd = QString("export LD_PRELOAD=%1 ; %2 x -y %3 ").arg( homePath.filePath("libgcc_s.so.1") ).arg( s7zipPath ).arg( ctr(curobj->path) );
#endif
		if (iLoc==0) return;

		iLoc = pSSD->getCheckedItemIndex();
		if (iLoc==0)
		{
			sCmd.append(" -o").append(PH_BASE_DIR);
			sCmd.append( QString(" ; chmod +x -R %1/ ;").arg( PH_BASE_DIR ) );
		}else{
			sCmd.append(" -o").append(SD_BASE_DIR);
			sCmd.append( QString(" ; chmod +x -R %1/ ;").arg( SD_BASE_DIR ) );
		}
		printf("%s\n",sCmd.ascii());
		sprintf(exec_buffer,"%s",sCmd.ascii());
#else

		QString sCmd = QString("%1 x -y %2 ").arg( homePath.filePath("unrar")).arg( ctr(curobj->path) );

		if (iLoc==0) return;

		iLoc = pSSD->getCheckedItemIndex();
		if (iLoc==0)
		{
			sCmd.append(PH_BASE_DIR);
			sCmd.append( QString(" ; chmod +x -R %1/ ;").arg( PH_BASE_DIR ) );
		}else{
			sCmd.append(SD_BASE_DIR);
			sCmd.append( QString(" ; chmod +x -R %1/ ;").arg( SD_BASE_DIR ) );
		}
		printf("%s\n",sCmd.ascii());
		sprintf(exec_buffer,"%s",sCmd.ascii());
#endif
		QTimer::singleShot(10, this, SLOT(system_exec()));
	
	}else{
		sprintf(execbuf, "exec '%s/%s' &", curobj->path, curobj->exec);
		printf("Debug: system(%s)\n", execbuf);
		system(execbuf);
	}
}


bool MpkgBoxGUI::Check7z()
{
	ZNoticeDlg *dlg;
	if (f7z_found)
		return false;

// /usr/local/freedom/p7zip
//	if (!QFile::exists( homePath.filePath("p7zip/7z") )) 
	if (!QFile::exists( s7zipPath )) 
	{
#ifdef EZX_ZN5
		s7zipPath = homePath.filePath("./p7zip/7z");
#endif

#ifdef EZX_Z6
		s7zipPath = homePath.filePath("/mmc/mmca1/.Programs/mgxbox/p7zip/7z");
#endif
		if (!QFile::exists( s7zipPath )) 
		{
			dlg=new ZNoticeDlg((ZNoticeDlg::Type)1, 2000, lc("Ошибка!"), lc("7Z не найден!"));
			dlg->setTitleIcon(ctr("error_pop.bmp"));
			dlg->exec();
			delete dlg;
			printf("Debug: 7z not exist!\n");
			return true;
		}
	}
	f7z_found = true;
	return false;
}

void MpkgBoxGUI::system_exec()
{
	if (exec_buffer[0]=='\0') {
		printf("Debug: invalid system_exec() call\n");
		return;
	}

	printf("Debug: system(%s)\n", exec_buffer);
	strcat(exec_buffer, " > /tmp/exec.log 2>&1");
	int ret=system(exec_buffer);
	ret>>=8;
	memset(exec_buffer, 0, 512);
	printf("Debug: system_exec() finished [%d]\n", ret);
	pleaseWaitDlg->hide();

	if (ret!=0) {
		QFile execlog("/tmp/exec.log");
		char *logContent=NULL;
		uint logSize=execlog.size();
		QString logString="";

		if (logSize>0 && execlog.open(IO_ReadOnly)) {
			logContent=(char *)malloc(logSize);
			execlog.readBlock(logContent, logSize);
			execlog.close();
			logString+=ctr(logContent);
		}

		ZMessageDlg *aboutDlg = new ZMessageDlg(lc("Ошибка!"), logString, (ZMessageDlg::MessageDlgType)2);
		aboutDlg->setTitleIcon(tr("error_pop.bmp"));
		aboutDlg->exec();
		delete aboutDlg;

		if (logContent!=NULL) free(logContent);
	}
	else
	{
		ZMessageDlg *finishDlg = new ZMessageDlg(lc("MgxBox"), lc("Операция выполнена успешно!"), (ZMessageDlg::MessageDlgType)2);
		finishDlg->exec();
		delete finishDlg;

		freeobj(sd_appobjects);
		freeobj(phone_appobjects);
		freeobj(sd_insobjects);
		sd_appobjects=NULL;
		phone_appobjects=NULL;
		sd_insobjects=NULL;
		initBoxes();
		
	}
	system("cat /tmp/exec.log");
	QFile::remove("/tmp/exec.log");
}
