/****************************************************************************
* Zn5 Mpkgbox port/modification by kidscracker
* E8 MpkgBox source file by ilove3d
* keep author information if you redistribute this program
* Nov. 2008
* http://moto.it168.com
*
*
* Ported by: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef MPKGBOXGUI_H_
#define MPKGBOXGUI_H_
#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES

#include <ZApplication.h>
#include <ZFormContainer.h>
#include <ZKbMainWidget.h>
#include <ZNavTabWidget.h>
#include <ZOptionsMenu.h>
#include <ZSoftKey.h>
#include <ZListBox.h>
#include <ZLabel.h>
#include <ZMessageDlg.h>
#include <ZNoticeDlg.h>
#include <ZSingleSelectDlg.h>
#include <ZLineEdit.h>
#include <ZGlobal.h>
#include "ZSingleCaptureDlg.h"
#include <RES_ICON_Reader.h>
#include <qtextcodec.h>
#include <qfile.h>
#include <qdir.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include "LanguageConfig.h"

#include <libgen.h>
// release level
//#define SD_BASE_DIR "/mmc/mmca1/.mpkgbox"
//#define PH_BASE_DIR "/mmc/movinand1/.mpkgbox"

// debug level
#define SD_BASE_DIR "/mmc/mmca1/mgxbox"

#define PH_BASE_DIR "/ezxlocal/download/mystuff/mgxbox"
#define SD_INSTALLERS_DIR "/mmc/mmca1"

struct appobj {
	char path[256]; // not shown in cfg file, but restore the dir path for this object
	// below stores cfg content, name, exec, icon must exist
	char name[64];
	char exec[64];
	char icon[64];
	char author[64];
	char version[64];
	char comment[512];
	struct appobj *next;
};

class MpkgBoxGUI : public ZKbMainWidget
{
	Q_OBJECT
	bool CardExist;
	ZFormContainer *zsv;
	ZSoftKey *SoftKey;
	ZOptionsMenu* menu;
	ZNavTabWidget *znavtabwidget;
	ZListBox* zlistbox_phone;
	ZListBox* zlistbox_sd;
	ZListBox* zlistbox_installers_sd;
	ZPopup *pleaseWaitDlg;
	RES_ICON_Reader iconReader;

public:
	MpkgBoxGUI(QWidget *parent=NULL);
	~MpkgBoxGUI();
	QString lc(const char *key);

	int basename(char *str) {
		int ret=0, k=0;
		for (; str[k]!='\0'; k++) {
			if (str[k]=='/') ret=k;
		}
		return ret+1;
	}

	void printobj(struct appobj *tmpobj);
	void freeobj(struct appobj *tmpobj);
	struct appobj *getCurObj();
	void append_sd_obj(struct appobj *tmpobj);
	void append_phone_obj(struct appobj *tmpobj);
	void delete_sd_obj(int index);
	void delete_phone_obj(int index);
	void append_obj_to_ui(struct appobj *tmpobj, ZListBox *target);
	void refreshView(); // make objects into listbox

	void preLoadApps(char* AppsPath, struct appobj **tmpobj);

	void initBoxes(); // init the objects

	bool Check7z();
public slots:
	void options();
	void system_exec();
	void rename();
	void move();
	void del();
	void props();
	void save();
	void about();
	void quit();
	void objectSelected(int);
};
#endif
